package com.example.beijing_daxing;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.BaseObservable;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableBoolean;
import androidx.databinding.ObservableField;

import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.Toast;

import com.example.beijing_daxing.adapter.CheckAdapter;
import com.example.beijing_daxing.base.AdapterClickCall;
import com.example.beijing_daxing.base.BaseActivity;
import com.example.beijing_daxing.base.MyRecultCall;
import com.example.beijing_daxing.base.MyResult;
import com.example.beijing_daxing.been.Stock;
import com.example.beijing_daxing.databinding.ActivityCheckBinding;
import com.example.beijing_daxing.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.Arrays;
import java.util.List;

public class CheckActivity extends BaseActivity implements AdapterClickCall {
    private ActivityCheckBinding binding;
    private CheckAdapter adapter;
    private List<Stock> list;
    private List<String> selectList;
    private ObservableBoolean state;
    private AlertDialog.Builder inputDialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_check);
        adapter = new CheckAdapter(this, this);
        state = new ObservableBoolean();
        binding.setAdapter(adapter);
        binding.setState(state);
        selectList = Arrays.asList(getResources().getStringArray(R.array.check_item));
        binding.checkItemSelect.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                var selectItem = selectList.get(position);
                state.set(selectItem.equals("正常"));
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        initRequest();
        initAlertDialog();


    }

    private void initAlertDialog() {
        final EditText editText = new EditText(this);
        inputDialog = new AlertDialog.Builder(this);
        inputDialog.setTitle("输入跳过原因").setView(editText);
        inputDialog.setPositiveButton("确定", (dialog, which) -> {
            var stock = list.get(tag);
            stock.setState("跳过");
            stock.setRemark(editText.getText().toString());
            adapter.notifyItemChanged(tag);
        });
    }

    private void initRequest() {
        OkGo.<MyResult>post(url + "/xj/select").params("user", SharedPreferencesUtils.getstring("user", "")).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 0) {
                    list = gson.fromJson(body.getData().toString(), new TypeToken<List<Stock>>() {
                    }.getType());
                    adapter.setList(list);
                    adapter.notifyDataSetChanged();
                    return;
                }
                Toast.makeText(CheckActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
            }
        });
    }
    private int subIndex=-1;
    @Override
    protected void sanRfid(List<String> epcs) {
        var text = epcs.get(0);
        binding.checkEpc.setText(text);
        Stock stock=new Stock();
        stock.setEpcCode(text);
        var index = list.indexOf(stock);
        if (index==-1){
            Toast.makeText(this, "轮挡扫描错误", Toast.LENGTH_SHORT).show();
            return;
        }
        subIndex=index;
    }


    public void check_submit(View view) {
        list.forEach(t->{
            if (t.getState().equals("未检")) return;
        });
        // OkGo.<MyResult>pos
    }
    public void check_stock(View view) {
        if (subIndex==-1) return;
        var stock = list.get(subIndex);
        stock.setState(binding.checkItemSelect.getSelectedItem().toString());
        stock.setRemark(binding.checkRemark.getText().toString());
        adapter.notifyItemChanged(subIndex);
        binding.checkRemark.setText(null);
        binding.checkEpc.setText(null);
    }

    private int tag;

    @Override
    public void clickItem(int index) {
        tag = index;
        inputDialog.show();
    }


}